"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createRouteMiddleware;

var _getHtmlGenerator = _interopRequireDefault(require("../getHtmlGenerator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createRouteMiddleware(service) {
  return (req, res) => {
    const path = req.path;

    if (path === '/__umiDev/routes') {
      res.setHeader('Content-Type', 'text/json');
      res.send(JSON.stringify(service.routes));
    } else {
      const htmlGenerator = (0, _getHtmlGenerator.default)(service);
      const content = htmlGenerator.getMatchedContent(path);
      res.setHeader('Content-Type', 'text/html');
      res.send(content);
    }
  };
}