"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _randomColor = _interopRequireDefault(require("random-color"));

var _assert = _interopRequireDefault(require("assert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = api => {
  const paths = api.paths,
        config = api.config;
  const absTemplatePath = (0, _path.join)(__dirname, '../../../../template/generators');
  return class Generator extends api.Generator {
    constructor(args, options) {
      super(args, options);

      if (config.routes) {
        throw new Error(`umi g page does not work when config.routes exists`);
      }
    }

    configuring() {}

    writing() {
      (0, _assert.default)(typeof this.args[0] === 'string', `name should be supplied`);
      const path = this.args[0].toString();
      const name = (0, _path.basename)(path);
      this.fs.copyTpl((0, _path.join)(absTemplatePath, 'page.js'), (0, _path.join)(paths.absPagesPath, `${path}.js`), {
        name
      });
      this.fs.copyTpl((0, _path.join)(absTemplatePath, 'page.css'), (0, _path.join)(paths.absPagesPath, `${path}.css`), {
        color: (0, _randomColor.default)().hexString()
      });
    }

  };
};

exports.default = _default;