"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _cheerio = _interopRequireDefault(require("cheerio"));

var _HTMLGenerator = _interopRequireDefault(require("../../html/HTMLGenerator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (service, opts = {}) => {
  const config = service.config,
        paths = service.paths,
        webpackConfig = service.webpackConfig,
        routes = service.routes;
  const chunksMap = opts.chunksMap;
  return new _HTMLGenerator.default({
    config,
    paths,
    routes,
    publicPath: webpackConfig.output.publicPath,
    chunksMap,

    modifyContext(context) {
      return service.applyPlugins('modifyHTMLContext', {
        initialValue: context
      });
    },

    modifyRouterBaseStr(str) {
      return str;
    },

    modifyPublicPathStr(str) {
      return str;
    },

    modifyMetas(memo) {
      return service.applyPlugins('addHTMLMeta', {
        initialValue: memo
      });
    },

    modifyLinks(memo) {
      return service.applyPlugins('addHTMLLink', {
        initialValue: memo
      });
    },

    modifyScripts(memo) {
      return service.applyPlugins('addHTMLScript', {
        initialValue: memo
      });
    },

    modifyStyles(memo) {
      return service.applyPlugins('addHTMLStyle', {
        initialValue: memo
      });
    },

    modifyHeadScripts(memo) {
      return service.applyPlugins('addHTMLHeadScript', {
        initialValue: memo
      });
    },

    modifyHTML(memo, {
      route
    }) {
      const $ = _cheerio.default.load(memo);

      service.applyPlugins('modifyHTMLWithAST', {
        initialValue: $,
        args: {
          route
        }
      });
      return $.html();
    }

  });
};

exports.default = _default;