"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _assert = _interopRequireDefault(require("assert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(api) {
  const config = api.service.config;

  api._registerConfig(() => {
    return api => {
      return {
        name: 'history',

        validate(val) {
          (0, _assert.default)(['browser', 'hash'].includes(val), `history should be browser or hash, but got ${val}`);
        },

        onChange() {
          api.service.restart(
          /* why */
          'Config history Changed');
        }

      };
    };
  });

  api.addEntryImportAhead(() => {
    if (config.history === 'hash') {
      return {
        source: 'history/createHashHistory',
        specifier: 'createHashHistory'
      };
    }

    return [];
  });
  api.modifyEntryHistory(memo => {
    if (config.history === 'hash') {
      return `createHashHistory()`;
    }

    return memo;
  });
}